Subject: bug#5718: scroll-margin in buffer with small line count.

From: Oleksandr Gavenko <[email-masked]>
Date: Sun, 14 Mar 2010 19:26:57 +0200

I have official Emacs 22.3 from FSF ftp server for Windows.

When set

(setq scroll-margin 4)

in buffer with window width 6 lines real margin value is 1
(so real line scrolling done when press <up> on second line
or when press <down> on fifth line).

Experiment show such dependence of real margin on line count:

lines      real-scroll-margin
3,4,5,6         1
7,8,9,10        2
11,12,13,14     3
 >15             4

I count from 3 as when try make less lines Emacs warn.

I think that whose modify scroll-margin want to see as many
as possible margin value up to its customization value.

This formula produce such values:

best-scroll-margin = min( (line_count - 1)/2,  scroll-margin)

So previous table changed to:

lines      best-scroll-margin
3,4             1
5,6             2
7,8             3
 >9              4

Also as you can see in proposal case
user switch start work from 9 lines in window, not 15!

Please implement described behaviour.

-- 
Best regards!